    setClass("opt", 
	representation(writecon = "logical", 
			writespec = "logical", 
			writenormspec = "logical", 
			writefit = "logical", 
			writefitivo = "logical",
			writeclperr = "logical",
			residplot = "logical", 
			plot = "logical", 
			output = "character",
			nnls = "logical", 
			divdrel = "logical", 
			plotkinspec = "logical",
			superimpose = "vector",
			xlab = "character",
			ylab = "character",
			title = "character",
			makeps = "character",
			linrange = "numeric",
			summaryplotrow = "numeric",
			summaryplotcol = "numeric",
			iter = "numeric",
			stderrclp = "logical",
			paropt="list", 
			addfilename = "logical",
			addest="vector", 
			kinspecerr = "logical",
			xlimspec = "vector",
			ylimspec = "vector",
			ylimspecplus = "vector",
			specinterpol = "logical",
			specinterpolpoints = "logical",
			specinterpolseg = "numeric",
			specinterpolbspline = "logical",
			samespecline = "logical",
			normspec = "logical",
			writespecinterpol = "logical", 
			nonnegclp = "logical"
			), 
        prototype = list(writecon = FALSE, 
			writespec = FALSE,
			writenormspec = FALSE,
			writefit = FALSE,
			writefitivo = FALSE,
			writeclperr = FALSE, 
			residplot = FALSE, 
			plotkinspec = FALSE,
			plot = TRUE,  
			addfilename = FALSE,
			divdrel = TRUE, 
			output = "ps", 
			nnls = FALSE,
			superimpose = vector(),
			paropt = list(),
			title = "",
			makeps = "",
			stderrclp = FALSE, 
			summaryplotrow = 4, 
			summaryplotcol = 4,
			linrange = 1,
			iter = 1, 
			addest=vector(), 
			kinspecerr = FALSE,
			ylimspecplus = vector(), 
			xlimspec = vector(),
			ylimspec = vector(),
			specinterpol = FALSE,
			specinterpolpoints = TRUE, 
			specinterpolseg = 50,
			specinterpolbspline = FALSE,
			normspec = FALSE,
			writespecinterpol = FALSE, 
			samespecline = FALSE,
			nonnegclp = FALSE
			))

setClass("kinopt", representation("opt",
			   notraces = "logical",
			   selectedtraces = "vector",
			   breakdown = "list",
			   FLIM = "logical", 
			   FLIMresidimag = "logical",
			   noFLIMsummary = "logical",
			   writerawcon = "logical",
			   plotcohcolspec = "logical", 
			   kinspecest = "logical",
			   writeplaincon = "list"),
        prototype = list( notraces = FALSE,
			   selectedtraces = vector(),
			   breakdown = list(),
			   writerawcon = FALSE,
			   plotcohcolspec = TRUE,
			   FLIM = FALSE,	
			   FLIMresidimag = TRUE, 
			   noFLIMsummary = FALSE,
			   xlab = "time",
			   ylab = "wavelength",
			   kinspecest = FALSE,
			   writeplaincon = list()))
setClass("massopt", representation("kinopt",
        axis.by = "numeric", scale.concen = "logical",
        nummaxtraces = "numeric"),
	prototype = list(normspec = TRUE, 
	axis.by = 30, scale.concen = TRUE,
	nummaxtraces = 0)
	)


setClass("specopt", representation("opt",
			   nospectra = "logical",
			   selectedspectra = "vector"),
        prototype = list( nospectra = FALSE,
			   selectedspectra = vector(),
			   xlab = "wavelength",
			   ylab = "time"))

